Index: classes/ezfsolrdocumentfieldobjectrelation.php
===================================================================
--- classes/ezfsolrdocumentfieldobjectrelation.php	(revision 21723)
+++ classes/ezfsolrdocumentfieldobjectrelation.php	(working copy)
@@ -263,7 +263,7 @@
                 $returnArray[$defaultFieldName] = $this->getPlainTextRepresentation();
                 $relatedObject = $this->ContentObjectAttribute->content();
 
-                if ( $relatedObject )
+                if ( $relatedObject AND $relatedObject->attribute( 'status' ) == 1 )
                 {
                     // 1st, add content fields of the related object.
                     $baseList = $this->getBaseList( $relatedObject->attribute( 'current' ) );
@@ -322,12 +322,12 @@
                     $subObjectID = $relationItem['contentobject_id'];
                     if ( !$subObjectID )
                         continue;
-                    $subObject = eZContentObjectVersion::fetchVersion( $relationItem['contentobject_version'], $subObjectID );
-                    if ( !$subObject )
+                    $subObject = eZContentObject::fetch( $subObjectID );
+                    if ( !$subObject OR $subObject->attribute( 'status' ) != 1 )
                         continue;
 
                     // 1st create aggregated metadata fields
-                    $metaAttributeValues = eZSolr::getMetaAttributesForObject( $subObject->attribute( 'contentobject' ) );
+                    $metaAttributeValues = eZSolr::getMetaAttributesForObject( $subObject );
                     foreach ( $metaAttributeValues as $metaInfo )
                     {
                         $submetaFieldName = ezfSolrDocumentFieldBase::generateSubmetaFieldName( $metaInfo['name'], $contentClassAttribute );
